unit DemoForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  APPPROP, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    cbxShowHint: TComboBox;
    Label1: TLabel;
    cbxException: TComboBox;
    Label2: TLabel;
    cbxLogException: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Label5: TLabel;
    Edit2: TEdit;
    Button3: TButton;
    TheApp: TApplicationProperties;
    Edit3: TEdit;
    Label6: TLabel;
    Edit4: TEdit;
    Label7: TLabel;
    UpDown2: TUpDown;
    UpDown3: TUpDown;
    Label8: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure cbxShowHintChange(Sender: TObject);
    procedure cbxExceptionChange(Sender: TObject);
    procedure cbxLogExceptionChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Button3Click(Sender: TObject);
    procedure TheAppException(Sender: TObject; E: Exception);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown3Click(Sender: TObject; Button: TUDBtnType);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function StrToBool(Value: string): boolean;
begin
  if (trim(LowerCase(Value)) = 'true') then result := true
  else result := false;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Holder: TStringList;
begin
  if not TheApp.LogException then ShowMessage('Turn on exception logging')
  else if not FileExists(TheApp.ErrorLog) then
     ShowMessage('Excuse me, please throw an exception first!')
  else begin
     Holder := TStringList.Create;
     Holder.LoadFromFile(TheApp.ErrorLog);
     ShowMessage(Holder.Text);
     Holder.Free;
     DeleteFile(TheApp.ErrorLog);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  MissingFile: TextFile;
begin
  AssignFile(MissingFile, ParamStr(0) + 'SomeFile.txt');
  Reset(MissingFile);
  CloseFile(MissingFile);
end;

procedure TForm1.cbxShowHintChange(Sender: TObject);
begin
  TheApp.ShowHint := StrToBool(cbxShowHint.Text);
end;

procedure TForm1.cbxExceptionChange(Sender: TObject);
begin
  TheApp.ShowException := StrToBool(cbxException.Text);
end;

procedure TForm1.cbxLogExceptionChange(Sender: TObject);
begin
  TheApp.LogException := StrToBool(cbxLogException.Text);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := ParamStr(0) + '\' + TheApp.ErrorLog;
  UpDown1.Position := TheApp.HintPause;
  UpDown2.Position := TheApp.HintShortPause;
  UpDown3.Position := TheApp.HintHidePause;
  if TheApp.LogException then cbxLogException.ItemIndex := 0
  else cbxLogException.ItemIndex := 1;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  TheApp.HintPause := UpDown1.Position
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  MissingFile: TextFile;
begin
  AssignFile(MissingFile, ParamStr(0) + 'SomeFile.txt');
  try
     Reset(MissingFile);
  except
     on E: EInOutError do
        TheApp.LogIt('This is a handled exception', E);
  end;
  CloseFile(MissingFile);
end;

procedure TForm1.TheAppException(Sender: TObject; E: Exception);
begin
  TheApp.LogIt('OnException logs: ', E);
end;



procedure TForm1.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
  TheApp.HintShortPause := UpDown2.Position
end;

procedure TForm1.UpDown3Click(Sender: TObject; Button: TUDBtnType);
begin
  TheApp.HintHidePause := UpDown3.Position
end;

end.

